package org.hmn.jrsd;
/*
 * 
 * Cree par Harry Karadimas a 10 oct. 08
 */
/**
 * Static utility methods specific to jrsd.
 */
public class JrsdUtils
{
  
  /**
   * Correct the name to make it a legal java identifier. Used to generated
   * syntactically correct field names from the column names, in 
   * {@link FieldDecl#setFieldName(String)}
   * @param name
   * @return
   */
  public static String correctForJava(String name)
  {
    StringBuffer sb = null; //on-demand construction of the buffer
    char[] ca = name.toCharArray();
    for (int i = 0; i < ca.length; i++) {
      char c = ca[i];
      if (i == 0 && !Character.isJavaIdentifierStart(c)) {
        //the first char is not allowed as a java identifier,
        //add a '_' to the start of the name
        if (sb == null) sb = new StringBuffer();
        sb.append('_');
      }//if
      if (Character.isJavaIdentifierPart(c)) {
        if (sb == null) sb = new StringBuffer();
        sb.append(c);
      }
      else {
        if (sb == null) sb = new StringBuffer();
        sb.append('_'); //replace illegal char with '_'
      }
    }//for
    if (sb == null) return name; //already a correct java identifier, return as it is
    return sb.toString();
  }
  
}
