package org.hmn.jrsd.rt;

import java.sql.SQLException;
import java.sql.Statement;

/*
 * 
 * Cree par Harry Karadimas a 3 avr. 08
 */
/**
 * Utility class that holds the static {@link #silently(Statement)} method
 * to close a statement, ignoring any {@link SQLException}
 */
public class JdbcClose
{
  
  /**
   * Silently close a JDBC statement (prepared or not). Useful inside
   * "finally" clauses.
   * @param st
   */
  public static final void silently(Statement st)
  {
    try { st.close(); }
    catch (SQLException ignored) {}
  }
  
}
