package org.hmn.jrsd.rt;

import java.util.ArrayList;
import java.util.List;

/*
 * 
 * Cree par Harry Karadimas a 5 oct. 2006
 */
/**
 * Literal expression, where you can put an arbitrary text and arbitrary
 * parameters. Beware of unclosed parentheses...
 * @author karadimas
 */
public class LiteralExpr
extends SqlExpr
{
  String literalText;
  ArrayList<Object> params = new ArrayList<Object>();

  /**
   * 
   */
  public LiteralExpr(String text) {
    this.literalText = text;
  }
  
  public LiteralExpr(String text, Object param) {
    this.literalText = text;
    addParameter(param);
  }
  
  public void addParameter(Object p) { params.add(p); }
  
  /**
   * @see org.hmn.jrsd.rt.SqlExpr#getText()
   */
  public String getText() {
    return literalText;
  }

  /**
   * @see org.hmn.jrsd.rt.SqlExpr#getParameters()
   */
  public List<?> getParameters() {
    return params;
  }
  
}
