package org.hmn.jrsd.rt.dbops;

import java.sql.SQLException;

import org.hmn.jrsd.rt.PrimaryKeysRetrievable;

import simpleorm.dataset.SRecordInstance;
import simpleorm.dataset.SRecordMeta;
import simpleorm.sessionjdbc.SSessionJdbc;

/*
 * 
 * Cree par Harry Karadimas a 2 mai 08
 */
/**
 * A standard delete operation on a SimpleOrm record.
 */
public class DbRecordDeleteOperation
extends DbUpdateOperation
{
  Object keys;
  SRecordMeta<?> meta;
  
  public DbRecordDeleteOperation(SRecordMeta<?> meta, Object keys)
  {
    this.meta = meta;
    this.keys = keys;
  }
  
  public DbRecordDeleteOperation(SRecordMeta<?> meta, PrimaryKeysRetrievable transportObj)
  {
    this(meta, transportObj.getPrimaryKeyValues());
  }
  
  public int execute()
  throws SQLException
  {
    SSessionJdbc session = SSessionJdbc.getThreadLocalSession();
    SRecordInstance rec = session.findOrCreate(meta, keys);    
    if (rec.isNewRow()) return 0;
    rec.deleteRecord();
    return 1;
  }

}
