package org.hmn.jrsd.rt.rows;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/*
 * 
 * Cree par Harry Karadimas a 5 fvr. 2007
 */
/**
 * 
 * @author karadimas
 */
public class JdbcResultRow
implements Serializable
{  
  private static final long serialVersionUID = 5915829452437625926L;
  
  JdbcResultRows rows; 
  int rowIndex;  
  
  public JdbcResultRow() {}
  
  public JdbcResultRow(JdbcResultRows rows, int rowIndex) {
    this.rows = rows;
    this.rowIndex = rowIndex;
  }
  
  /**
   * Take the recycled cells from the {@link JdbcResultRows} object and use
   * them to return a value of {@link JdbcResultCell}. This method is
   * inherently NOT thread-safe by design, as the cells are recycled with
   * each call.
   * @return
   */
  public List<JdbcResultCell> getList()
  {
    Object[] values = rows.getResults().getRowObjects(rowIndex);
    ArrayList<JdbcResultCell> cells = rows.recycledCells;
    for (int i = 0; i < values.length; i++) {
      JdbcResultCell cell = cells.get(i);
      cell.setColumn(rows.results.columns.getColumn(i));
      cell.setRawValue(values[i]);
      cell.setRowIndex(rowIndex);
      cell.setRow(this);
    }
    return cells;
  }

  public JdbcResultRows getJdbcResultRows()
  {
    return rows;
  }

  public void setJdbcResultRows(JdbcResultRows jdbcResultRows)
  {
    this.rows = jdbcResultRows;
  }

  public int getRowIndex()
  {
    return rowIndex;
  }

  public void setRowIndex(int rowIndex)
  {
    this.rowIndex = rowIndex;
  }
  
}
