package simpleorm.dataset; 
/*
 * 
 * Cree par Harry Karadimas a 2 janv. 09
 */
/**
 * A field that is automatically truncated to its maximum size if the string
 * value is longer. Useful if you don't care much about the content of the
 * field (a comment, a name, etc.) and don't want to bother with validation
 * code.
 */
public class SFieldTruncatedString
extends SFieldString
{

  private static final long serialVersionUID = 1L;

  public SFieldTruncatedString(SRecordMeta<?> meta, String columnName,
      int maxSize, SFieldFlags... pvals) {
    super(meta, columnName, maxSize, pvals);
  }
  
  /**
   * Override to truncate string if it is longer than the maximum allowed
   * length.
   * @see simpleorm.dataset.SFieldString#convertToDataSetFieldType(java.lang.Object)
   */
  @Override
  protected Object convertToDataSetFieldType(Object raw) {
    if (raw == null) return null;
    String str = raw.toString();
    if (str.length() > getMaxSize()) return str.substring(0, getMaxSize());
    return str;
  }

}
